library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
library UNISIM;
use UNISIM.VComponents.all;

entity SRAM16d is
    Port ( clk : in std_logic;
	we : in std_logic;
	add : in std_logic_vector(3 downto 0);
	di : in std_logic_vector(15 downto 0);
	do : out std_logic_vector(15 downto 0);
	dadd : in std_logic_vector(3 downto 0);
	ddo : out std_logic_vector(15 downto 0));
end SRAM16d;

architecture Behavioral of SRAM16d is
	signal bdi : STD_LOGIC_VECTOR(15 downto 0);
begin
GEN1:	for i in 0 to 15 generate
upu: RAM16X1D port map(WCLK=>clk, WE=>we, A0=>add(0), A1=>add(1), A2=>add(2), A3=>add(3), D=>di(i), SPO=>do(i),
	DPRA0=>dadd(0), DPRA1=>dadd(1), DPRA2=>dadd(2), DPRA3=>dadd(3), DPO=>ddo(i));
end generate;

end Behavioral;
